/* Classe Nucleo: esegue le query e scrive i file XML e XSL */
 
import java.sql.*;
import java.io.*;
import java.lang.String;
import java.text.*;
import java.util.*;
import javax.swing.*;
 
/* Variabili di classe e globali */
public class Nucleo {
  private final byte[] bitmap={66,77};
  private final byte[] gif={71,73};
  private final byte[] jpeg={-1,-40};
  private int lengthOfTask;
  private int current = 0;
  private int scatto=0;
  private int avanzamento;
  public  boolean fallimento=false;
  public String n = System.getProperty("line.separator");
  public String form="<FORM name=\"query\" ";
  public String intestazione="<?xml version=\"1.0\"?>"+n;
  
    
  Nucleo() {
    lengthOfTask = 100;
    form+="action=\"javascript:limita(query.where.value)\" method=\"POST\">"+n;
    form+="<DIV class=\"record\">Seleziona i record tali che:"+n;
    form+="<INPUT type=\"TEXT\" name=\"where\" size=\"40\" value=\"*\"/>"+n;
    form+="</DIV>"+n;
    form+="</FORM>"+n;
    intestazione+="<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/TR/WD-xsl\">"+n;
  }
 
/* Fa partire il task in runtime, utilizzando la classe SwingWorker */
  public void go() {
    current = 0;
    final SwingWorker worker = new SwingWorker() {
      public Object construct() {
        return new ActualTask();
      }
    };
    worker.start();
  }
 
/* Restituisce la lunghezza del task */
  public  int getLengthOfTask() {
    return lengthOfTask;
  }
    
/* Restituisce l'avanzamento attuale */
  public int getCurrent() {
    return current;
  }
 
/* Verifica se il task sia stato completato */
  public  boolean done() {
    if (current >= lengthOfTask) return true;
    else return false;
  }
 
/* Il task da eseguire in runtime */
  class ActualTask {
    ActualTask () {
      eseguiQuery();
      current=lengthOfTask;
    }
  }
    
/* Si occupa dell'esecuzione delle query */
  void eseguiQuery() {
    Vector vQuery=new Vector();
    Vector vFile=new Vector();
    Vector vStili=new Vector();
    vQuery=CreaXML.listaQuery;
    vFile=CreaXML.listaFile;
    vStili=CreaXML.listaStili;
    boolean nscape=CreaXML.css.getState();
    int i=-1;
    try {
      Class.forName (CreaXML.driver.getText());
      String DBurl=CreaXML.url.getText();
      String userName=CreaXML.user.getText();
      Connection con=DriverManager.getConnection
                     (DBurl,userName,new String(CreaXML.password.getPassword()));    
      checkForWarning (con.getWarnings ());
      fallimento=false;
      DatabaseMetaData dma=con.getMetaData();
      CreaXML.taskOutput.append("\nConnesso a: " + dma.getURL());
      CreaXML.taskOutput.append("\nDriver: " + dma.getDriverName());
      CreaXML.taskOutput.append("\nVersione: " +dma.getDriverVersion());
      CreaXML.taskOutput.append("\n");
      Statement stmt = con.createStatement ();     
      avanzamento=lengthOfTask/vFile.size();
      current=0;
      for (i=0;i<vFile.size();i++) {
 	String query=vQuery.get(i).toString();        
 	String nomeFile=vFile.get(i).toString();
 	String modello=vStili.get(i).toString();
        String nome=nomeFile.substring(0,nomeFile.length()-4);
 	String nomeTab=Utility.correggi(nome);
 	ResultSet rs = stmt.executeQuery (query);
        CreaXML.taskOutput.append("Sto eseguendo la query: "+query+"\n");
 	CreaXML.taskOutput.append("Sto scrivendo il file "+nomeTab+".xml ....\n");
 	scrolla();
 	boolean codice = dispResultSet(rs,nome,modello,nscape);
  	scrolla();
 	String stile="";
 	if (!(modello.equals(" "))) {
   	  CreaXML.taskOutput.append("Sto scrivendo il file "+nomeTab+".xsl ....\n");
   	  scrolla();
   	  if (modello.equals("Tabella")) stile=foglioStileTab(rs,nome);
     	  else {
	    if (modello.equals("Pagina")) stile=foglioStilePag(rs,nome);
	    else stile=foglioStileLis(rs,nome);
          }
   	  creaFile(stile,nomeTab+".xsl",false);
   	}
        if (nscape) {
          CreaXML.taskOutput.append("Sto scrivendo il file "+nomeTab+".css ....\n");
          String foglioCss=leggi("Css.css");
          int inizio=foglioCss.indexOf("{");
          foglioCss=foglioCss.substring(inizio);
          foglioCss=nomeTab+" "+foglioCss;
          creaFileHtml(foglioCss,nomeTab+".css");
        }
   	rs.close();
 	current+=avanzamento-scatto;
 	scatto=0;
      }
      stmt.close();
      con.close();
      if (CreaXML.pagIndice.getState()) {
        CreaXML.taskOutput.append("Sto scrivendo il file Indice.htm ....\n");
        String indice=creaIndice(vFile);
        creaFileHtml(indice,"Indice.htm");
      }  
      CreaXML.taskOutput.append("La scrittura dei file  stata completata con successo.\n");
      scrolla();
    }
    catch (SQLException ex) {
      String causa="";
      if (i!=-1) causa=" dalla query "+(i+1);
      CreaXML.taskOutput.append("\n*** Generata eccezione SQL"+causa+" ***");
      while (ex != null) {
 	CreaXML.taskOutput.append("\nStato: " +ex.getSQLState ());
 	CreaXML.taskOutput.append("\nMessaggio: " +ex.getMessage ());
 	CreaXML.taskOutput.append("\nCodice: " +ex.getErrorCode ());
 	ex = ex.getNextException ();
 	CreaXML.taskOutput.append("\n");
 	scrolla();
        fallimento=true;
      }
    }
    catch (java.lang.Exception ex) {
      CreaXML.taskOutput.append(ex.toString()+"\n");
      scrolla();
      fallimento=true;
    }    
  }
 
/* Verifica se ci sono oggetti SQLWarning. In caso positivo mostra i relativi messaggi */
  public  boolean checkForWarning (SQLWarning warn)  
    throws SQLException  {
    boolean rc = false;
    if (warn != null) {
      CreaXML.taskOutput.append("\n*** Attenzione! ***");
      rc = true;
      while (warn != null) {
 	CreaXML.taskOutput.append("\nStato: " +warn.getSQLState ());
 	CreaXML.taskOutput.append("\nMessaggio: " +warn.getMessage ());
 	CreaXML.taskOutput.append("\nCodice: " +warn.getErrorCode ());
 	CreaXML.taskOutput.append("\n");
 	warn = warn.getNextWarning ();
      }
    }
    return rc;
  }
 
/* Inserisce in una stringa il risultato della query in formato XML */
  public boolean dispResultSet (ResultSet rs, String nome, String modello, boolean css)
    throws SQLException,IOException {
    int i;
    String nomeTab=Utility.correggi(nome);
    ResultSetMetaData rsmd = rs.getMetaData ();
    int numCols = rsmd.getColumnCount ();
    String xml="<?xml version=\"1.0\" encoding=\"UTF-8\"?>"+n;
    xml+="<!DOCTYPE "+nomeTab+" ["+n;
    xml+="<!ELEMENT "+nomeTab+" (";
    if (css) {
      xml+="T,C,";
    }
    xml+="Item*)>"+n;
    xml+="<!ELEMENT Item (";
    String[] nomeCol = new String[numCols+1];
    for (i=1; i<=numCols; i++) {
      nomeCol[i]=controlla(rsmd.getColumnName(i),nomeTab);     
      xml+=nomeCol[i];
      if (i<numCols) xml+=",";
    }
    xml+=")>"+n;
    for (i=1; i<=numCols; i++) {
      xml+="<!ELEMENT ";
      xml+=nomeCol[i];
      xml+=" (#PCDATA)>"+n;
    }
    for (i=1; i<=numCols; i++) {
      if (rsmd.getColumnType(i)==Types.LONGVARCHAR) {
        xml+="<!ATTLIST ";
        xml+=nomeCol[i];
        xml+=" href CDATA #IMPLIED>"+n;
      }
    }
    if (css) {
      xml+="<!ELEMENT T (T_)>"+n;
      xml+="<!ELEMENT T_ (#PCDATA)>"+n;
      xml+="<!ELEMENT C (C_*)>"+n;
      xml+="<!ELEMENT C_ (#PCDATA)>"+n;
    }
    xml+="]>"+n;
    if (!(modello.equals(" ")))
      xml+="<?xml-stylesheet type=\"text/xsl\" href=\""+nomeTab+".xsl\"?>"+n;
    if (css) xml+="<?xml-stylesheet type=\"text/css\" href=\""+nomeTab+".css\"?>"+n;
    xml+="<"+nomeTab+">"+n;
    if (css) {
      xml+="<T><T_>"+cambiaCaratteri(nome)+"</T_></T>"+n;
      xml+="<C>"+n;
      for (i=1; i<=numCols; i++) {
        xml+="<C_>"+cambiaCaratteri(rsmd.getColumnLabel(i))+"</C_>"+n;
      }
      xml+="</C>"+n;
    }
    creaFile(xml,nomeTab+".xml",false);
    boolean more = rs.next ();
    int riga=0;
    int corrente=current; 
    while (more || riga==0) {
      ++riga;  
      String item="<Item>"+n;
      for (i=1; i<=numCols; i++) {
        if (more) {
 	  item+="<"+nomeCol[i];  
 	  String dato=formattaDato(rs,i,riga);
 	  if (dato==null) dato=" ";
      	  if (dato.endsWith("#")) {
            String alt=dato.substring(0,dato.indexOf('#'));
            String link=dato.substring(dato.indexOf('#')+1,dato.lastIndexOf('#'));
            item+=" href=\""+link+"\">"+alt; 
          }
 	  else item+=">"+cambiaCaratteri(dato);        
          item+="</"+nomeCol[i]+">"+n;
        }
        else item+="<"+nomeCol[i]+"/>"+n;
      }
      item+="</Item>"+n;
      scatto=riga/50;
      if (scatto>=avanzamento) scatto=avanzamento-1;
      current=corrente+scatto;
      more = rs.next ();
      if (!more) item+="</"+nomeTab+">";
      creaFile(item,nomeTab+".xml",true);
    }
    return true;
  }
 
/* Crea il foglio di stile XSL seguendo il modello Tabella */
  public  String foglioStileTab(ResultSet rs, String nome)
    throws SQLException,IOException {
    int i;
    String nomeTab=Utility.correggi(nome);
    String labelTab=cambiaCaratteri(nome);
    String html=leggi("Tabella.htm");
    int inizioStile=html.indexOf("")+5;
    int fineStile=html.lastIndexOf("</STYLE>")+8;
    String style=html.substring(inizioStile,fineStile);
    String template=leggi("Tabella.st");
    ResultSetMetaData rsmd = rs.getMetaData ();
    int numCols = rsmd.getColumnCount ();
    String[] nomeCol = new String[numCols+1];
    String xsl=intestazione;
    xsl+="<xsl:template match=\"/\">"+n;
    xsl+="<HTML>"+n;
    xsl+=style;
    xsl+=template;
    xsl+="<TITLE>"+labelTab+"</TITLE>"+n;
    xsl+="<H1 align=\"center\">"+labelTab+"</H1>"+n;
    int inizio1=html.indexOf("",fineStile)+5;
    int fine1=html.indexOf("<DIV id=\"tabella\">");
    String blocco1=html.substring(inizio1,fine1);
    xsl+=blocco1;
    xsl+="<DIV id=\"tabella\">";
    xsl+="<xsl:apply-templates select=\""+nomeTab+"\"/></DIV>"+n;
    xsl+="</HTML>"+n+"</xsl:template>"+n;
    xsl+="<xsl:template match=\""+nomeTab+"\">"+n;
    xsl+="<CENTER>"+n;
    xsl+="<TABLE BORDER=\"1\" BGCOLOR=\"white\" onMouseover=\"cambiaCol(\'lightgreen\')\"";
    xsl+=" onMouseout=\"torna(\'white\')\">"+n+"<TR>"+n;
    for (i=1; i<=numCols; i++) {
      nomeCol[i]=controlla(rsmd.getColumnName(i),nomeTab);    
      xsl+="<TH class=\"header\"";
      xsl+=" onClick=\"sort(\'"+tipo(rs,i,nomeCol[i])+"\')\">";
      xsl+=cambiaCaratteri(rsmd.getColumnLabel(i))+"</TH>"+n;
    }
    xsl+="</TR>"+n;
    xsl+="<xsl:for-each select=\"Item\"";
    String chiave=nomeCol[1];
    String pattern=tipo(rs,1,chiave);
    xsl+=" order-by=\"+"+pattern+"\">"+n;
    xsl+="<TR>"+n;
    for (i=1; i<=numCols; i++) {
      String valore="<xsl:value-of select=\""+nomeCol[i]+"\"/>"+n;
      
      xsl+="<TD class=\""+allin(rs,i)+"\">"+n;
      if (rsmd.getColumnType(i)==Types.LONGVARCHAR) { //Supporto dei link di Access
        xsl+="<xsl:choose>"+n;
 	xsl+="<xsl:when test=\""+nomeCol[i]+"/@href\">"+n;
 	xsl+="<xsl:element name=\"A\"><xsl:attribute name=\"href\">"+n;
    	xsl+="<xsl:value-of select=\""+nomeCol[i]+"/@href\"/>"+n;
 	xsl+="</xsl:attribute>"+n;
 	xsl+=valore;
 	xsl+="</xsl:element>"+n;
 	xsl+="</xsl:when>"+n;
 	xsl+="<xsl:otherwise>"+n+valore;
 	xsl+="</xsl:otherwise>"+n+"</xsl:choose>"+n;
      }
      else {
 	if ((rsmd.getColumnType(i)==Types.LONGVARBINARY) ||
	    (rsmd.getColumnTypeName(i).equals("BLOB")))	 { //Supporto delle immagini
   	  xsl+="<xsl:element name=\"A\"><xsl:attribute name=\"HREF\">"+n;
   	  xsl+=valore;
   	  xsl+="</xsl:attribute>"+n;
   	  xsl+="<xsl:element name=\"IMG\">"+n;
   	  xsl+="<xsl:attribute name=\"SRC\">"+n;
   	  xsl+=valore;
   	  xsl+="</xsl:attribute>"+n;
          xsl+="<xsl:attribute name=\"ALT\">";
   	  xsl+=valore;
   	  xsl+="</xsl:attribute>"+n;
   	  xsl+="<xsl:attribute name=\"HEIGHT\">50</xsl:attribute>"+n;
   	  xsl+="<xsl:attribute name=\"WIDTH\">50</xsl:attribute>"+n;
   	  xsl+="</xsl:element></xsl:element>"+n;
        }
        else xsl+=valore;
      }
      xsl+="</TD>"+n;
    }
    xsl+="</TR>"+n;
    xsl+="</xsl:for-each>"+n;
    xsl+="</TABLE>"+n;
    xsl+="</CENTER>"+n;
    xsl+="<HR/>"+n;
    xsl+=form;
    int inizio2=html.indexOf("",fine1)+5;
    int fine2=html.indexOf("</HTML>");
    String blocco2=html.substring(inizio2,fine2);
    xsl+=blocco2;
    xsl+="</xsl:template>"+n;
    xsl+="</xsl:stylesheet>"+n;
    return xsl;
  }
 
/* Crea il foglio di stile XSL seguendo il modello Pagina */
  public  String foglioStilePag(ResultSet rs, String nome)
    throws SQLException,IOException {
    int i;
    String nomeTab=Utility.correggi(nome);
    String labelTab=cambiaCaratteri(nome);
    String html=leggi("Pagina.htm");
    int inizioStile=html.indexOf("")+5;
    int fineStile=html.lastIndexOf("</STYLE>")+8;
    String style=html.substring(inizioStile,fineStile);
    String template=leggi("Pagina.st");
    ResultSetMetaData rsmd = rs.getMetaData ();
    int numCols = rsmd.getColumnCount ();
    String[] nomeCol = new String[numCols+1];
    String xsl=intestazione;
    xsl+="<xsl:template match=\"/\">"+n;
    xsl+="<HTML>"+n+"<HEAD>"+n;
    xsl+=style;
    xsl+=template;
    xsl+="<TITLE>"+labelTab+"</TITLE>"+n;
    xsl+="</HEAD>"+n;
    xsl+="<BODY background=\"sfondo.jpg\" link=\"cyan\" vlink=\"pink\">"+n;
    xsl+="<H1 align=\"center\">"+labelTab+"</H1>"+n;
    int inizio1=html.indexOf("",fineStile)+5;
    int fine1=html.indexOf("<DIV id=\"record\">");
    String blocco1=html.substring(inizio1,fine1);
    xsl+=blocco1;
    xsl+="<DIV id=\"record\">";
    xsl+="<xsl:apply-templates select=\""+nomeTab+"\"/></DIV>"+n;
    xsl+="</BODY>"+n;
    xsl+="</HTML>"+n+"</xsl:template>"+n;
    xsl+="<xsl:template match=\""+nomeTab+"\">"+n;
    xsl+="<xsl:for-each select=\"Item[*][0]\"";
    for (i=1; i<=numCols; i++) {
       nomeCol[i]=controlla(rsmd.getColumnName(i),nomeTab);    
    }
    String chiave=nomeCol[1];
    String pattern=tipo(rs,1,chiave);
    xsl+=" order-by=\"+"+pattern+"\">"+n;
    xsl+="<DIV class=\"record\">Record: ";
    xsl+="<SPAN id=\"attuale\">1</SPAN> di"+n;
    xsl+="<SPAN id=\"finale\">"+n;
    xsl+="<xsl:eval>childNumber(this.selectSingleNode(\"//Item[end()]\"))</xsl:eval>"+n;
    xsl+="</SPAN>"+n;
    xsl+="</DIV>"+n;
    String tasti="<DIV class=\"record\">"+n;
    tasti+="<A HREF=\"javascript:primo()\"><IMG SRC=\"first.gif\" ";
    tasti+="BORDER=\"0\" WIDTH=\"40\" HEIGHT=\"28\" ALT=\"Primo Record\"/></A>"+n;
    tasti+="<A HREF=\"javascript:diminuisci()\"><IMG SRC=\"prev.gif\" ";
    tasti+="BORDER=\"0\" WIDTH=\"40\" HEIGHT=\"28\" ALT=\"Record precedente\"/></A>"+n;
    tasti+="<A HREF=\"javascript:aumenta()\"><IMG SRC=\"next.gif\" ";
    tasti+="BORDER=\"0\" WIDTH=\"40\" HEIGHT=\"28\" ALT=\"Prossimo record\"/></A>"+n;
    tasti+="<A HREF=\"javascript:ultimo()\"><IMG SRC=\"last.gif\" ";
    tasti+="BORDER=\"0\" WIDTH=\"40\" HEIGHT=\"28\" ALT=\"Ultimo record\"/></A>"+n;
    tasti+="</DIV>"+n;
    xsl+=tasti;
    xsl+="<HR SIZE=\"8\"/>"+n;
    for (i=1; i<=numCols; i++) {
      xsl+="<xsl:if test=\""+nomeCol[i]+"[.!=\'\']\">"+n;
      String valore="<xsl:value-of select=\""+nomeCol[i]+"\"/>"+n;
      xsl+="<DIV class=\"colonna\">"+cambiaCaratteri(rsmd.getColumnName(i))+":</DIV>"+n;
      xsl+="<DIV class=\"dato\">"+n;
      if (rsmd.getColumnType(i)==Types.LONGVARCHAR) { //Supporto dei link di Access
        xsl+="<xsl:choose>"+n;
 	xsl+="<xsl:when test=\""+nomeCol[i]+"/@href\">"+n;
 	xsl+="<xsl:element name=\"A\"><xsl:attribute name=\"href\">"+n;
 	xsl+="<xsl:value-of select=\""+nomeCol[i]+"/@href\"/>"+n;
 	xsl+="</xsl:attribute>";
 	xsl+=valore;
 	xsl+="</xsl:element>"+n;
 	xsl+="</xsl:when>"+n;
 	xsl+="<xsl:otherwise>"+n+valore;
 	xsl+="</xsl:otherwise>"+n+"</xsl:choose>"+n;
      }
      else {
 	if ((rsmd.getColumnType(i)==Types.LONGVARBINARY) ||
	    (rsmd.getColumnTypeName(i).equals("BLOB")))	 { //Supporto delle immagini
   	  xsl+="<xsl:element name=\"IMG\">"+n;
   	  xsl+="<xsl:attribute name=\"SRC\">"+n;
   	  xsl+=valore;
	  xsl+="</xsl:attribute>"+n;
   	  xsl+="<xsl:attribute name=\"ALT\">"+n;
   	  xsl+=valore;
   	  xsl+="</xsl:attribute>"+n;
    	  xsl+="</xsl:element>"+n;
        }
        else xsl+=valore;
      }
      xsl+="</DIV>"+n;
      xsl+="</xsl:if>"+n;
    }
    xsl+="<HR SIZE=\"8\"/>";
    xsl+=form;
    xsl+="<HR SIZE=\"8\"/>";
    xsl+="<DIV class=\"record\">Record: ";
    xsl+="<SPAN id=\"attuale2\">1</SPAN> di"+n;
    xsl+="<SPAN id=\"finale2\">"+n;
    xsl+="<xsl:eval>childNumber(this.selectSingleNode(\"//Item[end()]\"))</xsl:eval>"+n;
    xsl+="</SPAN>"+n;
    xsl+="</DIV>"+n;
    xsl+=tasti;
    xsl+="<FORM name=\"vai\" ";
    xsl+="action=\"javascript:cambia(vai.destinazione.value)\" method=\"POST\">"+n;
    xsl+="<DIV class=\"record\">Vai al record:"+n;
    xsl+="<INPUT type=\"TEXT\" name=\"destinazione\" size=\"1\" value=\"1\"/>"+n;
    xsl+="</DIV>"+n;
    xsl+="</FORM>"+n;
    int inizio2=html.indexOf("",fine1)+5;
    int fine2=html.indexOf("</BODY>");
    String blocco2=html.substring(inizio2,fine2);
    xsl+=blocco2;
    xsl+="</xsl:for-each>"+n;
    xsl+="</xsl:template>"+n;
    xsl+="</xsl:stylesheet>"+n;
    return xsl;
  }

/* Crea il foglio di stile XSL seguendo il modello Lista */
  public  String foglioStileLis(ResultSet rs, String nome)
    throws SQLException,IOException {
    int i;
    String nomeTab=Utility.correggi(nome);
    String labelTab=cambiaCaratteri(nome);
    ResultSetMetaData rsmd = rs.getMetaData ();
    int numCols = rsmd.getColumnCount ();
    String[] nomeCol = new String[numCols+1];
    String xsl=intestazione;
    xsl+=leggi("Lista.st");
    String html=leggi("Lista.htm");
    int inizioStile=html.indexOf("")+5;
    int fineStile=html.lastIndexOf("</STYLE>")+8;
    String style=html.substring(inizioStile,fineStile);
    xsl+=style;
    xsl+="<TITLE>"+labelTab+"</TITLE>"+n;
    xsl+="<H1 align=\"center\">"+labelTab+"</H1>"+n;
    int inizio1=html.indexOf("",fineStile)+5;
    int fine1=html.indexOf("<HR/>");
    String blocco1=html.substring(inizio1,fine1);
    xsl+=blocco1;
    xsl+="<FORM name=\"menu\">"+n;
    xsl+="<P align=\"center\">Ordina per:"+n;
    xsl+="<SELECT name=\"colonne\" size=\"1\">"+n;
    for (i=1; i<=numCols; i++) {
      nomeCol[i]=controlla(rsmd.getColumnName(i),nomeTab);    
    }
    String chiave=nomeCol[1];
    String pattern=tipo(rs,1,chiave);
    for (i=1; i<=numCols; i++) { 
      xsl+="<OPTION ";
      if (i==1) xsl+="selected=\"\" ";
      xsl+="value=\""+tipo(rs,i,nomeCol[i])+"\">";
      xsl+=cambiaCaratteri(rsmd.getColumnName(i))+"</OPTION>"+n;
    }
    xsl+="</SELECT>"+n;
    xsl+="<INPUT TYPE=\"radio\" NAME=\"crescente\" VALUE=\"+\" CHECKED=\"\"/>"+n;
    xsl+="crescente";
    xsl+="<INPUT TYPE=\"radio\" NAME=\"crescente\" VALUE=\"-\"/>decrescente"+n;
    xsl+="<INPUT type=\"button\" name=\"button\" value=\" Vai! \"";
    xsl+=" onclick=\"javascript:sort(menu.colonne.options[menu.colonne.selectedIndex].value,";
    xsl+="menu.crescente[0].checked);\"/>"+n;
    xsl+="</P>"+n+"</FORM>"+n;
    xsl+="<HR/>"+n;
    xsl+="<DIV id=\"lista\">";
    xsl+="<xsl:apply-templates select=\""+nomeTab+"\"/></DIV>"+n;
    xsl+="</xsl:template>"+n;
    xsl+="<xsl:template match=\""+nomeTab+"\">"+n;
    xsl+="<xsl:for-each select=\"//Item\"";
    xsl+=" order-by=\"+"+pattern+"\">"+n;
    xsl+="<DIV>"+n;
    xsl+="<xsl:attribute name=\"STYLE\">background-color:"+n;
    xsl+="<xsl:eval>whichColor(this)</xsl:eval>"+n;
    xsl+="</xsl:attribute>"+n;
    xsl+="<TABLE BORDER=\"0\" WIDTH=\"100%\">"+n;
    xsl+="<TR>"+n;   
    for (i=1; i<=numCols; i++) {         
      String valore="<xsl:value-of select=\""+nomeCol[i]+"\"/>"+n;
      xsl+="<TD WIDTH=\"50%\">"+cambiaCaratteri(rsmd.getColumnName(i))+":"+n;
      xsl+="<SPAN class=\"dato\">"+n;
      if (rsmd.getColumnType(i)==Types.LONGVARCHAR) { //Supporto dei link di Access
        xsl+="<xsl:choose>"+n;
 	xsl+="<xsl:when test=\""+nomeCol[i]+"/@href\">"+n;
 	xsl+="<xsl:element name=\"A\"><xsl:attribute name=\"href\">"+n;
 	xsl+="<xsl:value-of select=\""+nomeCol[i]+"/@href\"/>"+n;
 	xsl+="</xsl:attribute>"+n;
 	xsl+=valore;
 	xsl+="</xsl:element>"+n;
 	xsl+="</xsl:when>"+n;
 	xsl+="<xsl:otherwise>"+n+valore;
 	xsl+="</xsl:otherwise>"+n+"</xsl:choose>"+n;
      }
      else {
 	if ((rsmd.getColumnType(i)==Types.LONGVARBINARY) ||
	    (rsmd.getColumnTypeName(i).equals("BLOB")))	 { //Supporto delle immagini
   	  xsl+="<xsl:element name=\"A\">"+n;
   	  xsl+="<xsl:attribute name=\"HREF\">"+n;
   	  xsl+=valore;
   	  xsl+="</xsl:attribute>"+n;
          xsl+=valore;
    	  xsl+="</xsl:element>"+n;
        }
        else xsl+=valore;
      }
      xsl+="</SPAN>"+n;
      xsl+="</TD>"+n;
      if ((i%2==0)&&(i<numCols)) xsl+="</TR>"+n+"<TR>"+n;
    }
    xsl+="</TR>"+n;
    xsl+="</TABLE>"+n;
    xsl+="</DIV>"+n;
    xsl+="<HR/>"+n;
    xsl+="</xsl:for-each>"+n;
    xsl+=form;
    int inizio2=html.indexOf("",fine1)+5;
    int fine2=html.indexOf("</HTML>");
    String blocco2=html.substring(inizio2,fine2);
    xsl+=blocco2;
    xsl+="</xsl:template>"+n;
    xsl+="</xsl:stylesheet>"+n;
    return xsl;
  } 

  String creaIndice(Vector titoli) throws IOException {
    DateFormat formatoTempo=
      DateFormat.getDateTimeInstance(DateFormat.LONG,DateFormat.SHORT,Locale.ITALIAN);
    String html=leggi("I.htm");
    int fineStile=html.indexOf("<UL>")+4;
    String style=html.substring(0,fineStile);
    String ind=style;
    for (int i=0;i<titoli.size();i++) {
      ind+="<LI><A HREF=\"";
      String pagina=titoli.get(i).toString();
      ind+=Utility.correggi(pagina)+"\">";
      ind+=pagina.substring(0,pagina.lastIndexOf(".xml"));
      ind+="</A></LI>"+n;
    }
    ind+="</UL>"+n;
    int inizio1=html.indexOf("",fineStile)+5;
    int fine1=html.indexOf("<HR/>");
    String blocco1=html.substring(inizio1,fine1);
    ind+=blocco1;
    ind+="<HR/>"+n;
    ind+="<P>Ultimo aggiornamento il ";
    String data=formatoTempo.format(new java.util.Date());
    ind+=data+"</P>"+n;
    ind+="</BODY>"+n;
    ind+="</HTML>"+n;
    return ind;
  }

/* Modifica l'ordinamento a seconda del tipo di dati */
  public  String tipo(ResultSet rs, int col, String chiave) 
  throws SQLException {
    ResultSetMetaData meta=rs.getMetaData();
    switch (meta.getColumnType(col)) {
      case Types.TINYINT:
      case Types.SMALLINT:
      case Types.INTEGER:
      case Types.BIGINT:
      case Types.FLOAT:
      case Types.REAL:
      case Types.DOUBLE:
      case Types.NUMERIC:
      case Types.DECIMAL: return "number("+chiave+")";
      case Types.TIMESTAMP: return "date("+chiave+")";
      case Types.TIME: return "time("+chiave+")";
      case Types.DATE: return "date("+chiave+")";
      default: return chiave;
    }
  }
 
/* Modifica l'allineamento a seconda del tipo di dati */
  public  String allin(ResultSet rs, int col) 
  throws SQLException {
    ResultSetMetaData meta=rs.getMetaData();
    switch (meta.getColumnType(col)) {
      case Types.TINYINT: 
      case Types.SMALLINT: 
      case Types.INTEGER: 
      case Types.BIGINT: 
      case Types.FLOAT: 
      case Types.REAL: 
      case Types.DOUBLE: 
      case Types.NUMERIC: 
      case Types.DECIMAL: 
      case Types.TIMESTAMP: 
      case Types.TIME: 
      case Types.DATE: return "numero";
      default: return "stringa";
    }
  }
 
/* Modifica la formattazione a seconda del tipo di dati */
  public  String formattaDato(ResultSet rs, int col, int riga)
  throws SQLException,IOException {
    ResultSetMetaData meta=rs.getMetaData();  
    
    NumberFormat formato=NumberFormat.getNumberInstance(Locale.ITALIAN);
    DateFormat formatoData=DateFormat.getDateInstance(DateFormat.LONG,Locale.ITALIAN);
    DateFormat formatoTempo=
      DateFormat.getDateTimeInstance(DateFormat.LONG,DateFormat.SHORT,Locale.ITALIAN);
try {
    switch (meta.getColumnType(col)) {
      case Types.BIT: return (rs.getBoolean(col)==true ? "S":"No");
      case Types.FLOAT:
      case Types.DOUBLE:
      case Types.NUMERIC:
      case Types.DECIMAL:
      case Types.REAL: return formato.format(rs.getDouble(col));
      case Types.DATE: return formatoData.format(rs.getTimestamp(col)); 
      case Types.TIME: return rs.getTime(col).toString();     
      case Types.CLOB: return rs.getClob(col).toString();
      case Types.ARRAY:
      case Types.BINARY: 
      case Types.DISTINCT: 
      case Types.JAVA_OBJECT: return "Oggetto non supportato";
      case Types.LONGVARBINARY: {
        String nomeFile=Utility.correggi(meta.getColumnName(col)+riga);
 	nomeFile+=creaFileBinario(rs,col,nomeFile);
        CreaXML.taskOutput.append("Sto scrivendo il file "+nomeFile+"\n");
        scrolla();
 	return nomeFile;
      }
      
      case Types.OTHER: 
      case Types.REF: 
      case Types.STRUCT: return "Oggetto non supportato";
      case Types.VARBINARY: return "Oggetto non supportato: variabile binaria";
      case Types.TIMESTAMP: {     
 	String tempo=formatoTempo.format(rs.getTimestamp(col));
 	int lungTempo=tempo.length();
 	if (tempo.endsWith(" 0.00")) return tempo.substring(0,lungTempo-5);
 	if (tempo.indexOf("1899")!=-1) return tempo.substring(lungTempo-5);
 	return tempo;
      }
      case Types.LONGVARCHAR: {
        try {
	  return rs.getString(col);      
        }
        catch (SQLException ex) {
          return " ";
        }
      }
      default: if (meta.getColumnTypeName(col).equals("BLOB"))  {
        String nomeFile=Utility.correggi(meta.getColumnName(col)+riga);
        nomeFile+=creaFileBinario(rs,col,nomeFile);
        CreaXML.taskOutput.append("Sto scrivendo il file "+nomeFile+"\n");
 	return nomeFile;
      }
      else return rs.getString(col);
   
 
    }
    }
catch (java.lang.NullPointerException ex) {
return " ";
}
  }
 

/* Scrive il file XML, eliminando i caratteri con codice ASCII superiore a 127 */
  public  void creaFile(String stringa,String nome, boolean append) throws IOException {
    FileWriter documento = new FileWriter(CreaXML.path+nome,append);
    for(int i=0;i<stringa.length();++i) {
      char c=stringa.charAt(i);
      int code=c;
      if (c<=127) documento.write(c);
    }
    documento.close();
  }
 
 public  void creaFileHtml(String stringa,String nome) throws IOException {
    FileWriter documento = new FileWriter(CreaXML.path+nome);
    for(int i=0;i<stringa.length();++i) {
      char c=stringa.charAt(i);
      documento.write(c);
    }
    documento.close();
  }

/* Lettura di un file-modello */
  public  String leggi(String nome) throws IOException {
    File inputFile = new File(nome);
    FileReader in = new FileReader(inputFile);
    String modello="";
    int c;
    while ((c = in.read()) != -1)
      modello+=((char) c);
    in.close();
    return modello;
  }
 

/* Sostituisce i caratteri che non possono comparire nel testo con gli opportuni riferimenti */
  public  String cambiaCaratteri(String stringa) {
    String corretto=""; 
    for(int i=0;i<stringa.length();++i) {
      char c=stringa.charAt(i);
      switch (c) {
 	case '&':
   	  corretto+="&amp;";
   	  break;
 	case '<':
    	  corretto+="&lt;";
   	  break;
 	case '>':
   	  corretto+="&gt;";
   	  break;
 	case '\'':
   	  corretto+="&apos;";
   	  break;
 	case '\"':
          corretto+="&quot;";
   	  break;
 	default: {
   	  int code=c;
   	  String unicode=String.valueOf(code);
   	  if (c>127) corretto+="&#"+unicode+";";
   	  else corretto+=c;
  	}
      }
    }
    return corretto; 
  }
 
/* Scrittura di un file binario */
  public String creaFileBinario(ResultSet rs,int col,String nome) 
    throws SQLException {
    String estensione="";
    int offset=0;
    try {
      InputStream is = rs.getBinaryStream(col);
      if (rs.wasNull()) {
 	if (is != null) is.close();
      }
        

   
     
      byte[] magico=new byte [4096];
      int lungMagico=is.read(magico);
      for (int j=1;j<lungMagico;j++) {
      
      
      
      if (magico[j-1]==bitmap[0] && magico[j]==bitmap[1]) {
        estensione+=".bmp";
        offset=j-1;
        break;
      }
      if (magico[j-1]==gif[0] && magico[j]==gif[1]) {
        estensione+=".gif";
        offset=j-1;
        break;
      }        
      if (magico[j-1]==jpeg[0] && magico[j]==jpeg[1]) {
        estensione+=".jpg";
        offset=j-1;
        break;
      }        
   
       if (j==lungMagico-1) {
	CreaXML.taskOutput.append("Non sono riuscito a riconoscere il tipo di "+nome+"\n");
        scrolla();   
      }
      }

      BufferedOutputStream fis = 
        new BufferedOutputStream(new FileOutputStream(CreaXML.path+nome+estensione));
      fis.write(magico,offset,lungMagico-offset);
      byte[] buff = new byte[1024];
      for (;;) {
 	int size = is.read(buff);
 	if (size == -1)
 	break;
 	fis.write(buff,0,size);
      }
      fis.flush();
      fis.close();
      is.close();
    }
    catch(IOException e) {
      CreaXML.taskOutput.append("Errore: "+e+" di I/O\n");      
    }
  return estensione;
  }
 


/* Fa scrollare la finestra di output */
  void scrolla() {
   CreaXML.taskOutput.setCaretPosition(CreaXML.taskOutput.getDocument().getLength());
  }

  String controlla(String nomeProposto, String nomeTab) {
      String nome=Utility.correggi(nomeProposto);        
      if (nome.equals(nomeTab) || nome.equals("Item") 
          || nome.equals("T_") || nome.equals("C_")) nome+="_";
      if (nome.equals("T") || nome.equals("C")) nome+="___";
      return nome;     
  }




}


