/* Classe setupDB: si occupa della connessione al DB */

import java.sql.*;
import java.util.*;

public class Setup {
  public static Vector setupDB(String Driver, String Db, String User, char[] pwd) {
    String[] tipiTabella = {"TABLE","QUERY","SYNONYM","ALIAS"};
    Vector nomi=new Vector();
    try {
      Class.forName(Driver);
      Connection con =DriverManager.getConnection(Db,User,new String(pwd));
      checkForWarning (con.getWarnings ());
      DatabaseMetaData dma = con.getMetaData ();
      CreaXML.taskOutput.append("\nConnesso a: " + dma.getURL());
      CreaXML.taskOutput.append("\nDriver: " + dma.getDriverName());
      CreaXML.taskOutput.append("\nVersione: " +dma.getDriverVersion());
      CreaXML.taskOutput.append("\n");    
      Statement stmt = con.createStatement ();
      ResultSet tabelle = dma.getTables(null,null,null,tipiTabella);
      while (tabelle.next()) {      
	String nome=tabelle.getString(3);
	nomi.add(nome);
      }
      tabelle.close();
      stmt.close();
      con.close();
    }
    catch (SQLException ex) {
      CreaXML.taskOutput.append ("\n*** Generata eccezione SQL ***\n");
      while (ex != null) {
	CreaXML.taskOutput.append ("Stato    : " +ex.getSQLState ());
	CreaXML.taskOutput.append ("\nMessaggio: " +ex.getMessage ());
	CreaXML.taskOutput.append ("\nCodice   : " +ex.getErrorCode ());
	ex = ex.getNextException ();
	CreaXML.taskOutput.append ("\n");
      }
    }
    catch (java.lang.Exception ex) {
      CreaXML.taskOutput.append(ex.toString()+"\n");
    }
  return nomi;
  }

/* Verifica se ci sono oggetti SQLWarning. In caso positivo mostra i relativi messaggi */
  public static boolean checkForWarning (SQLWarning warn) 	
    throws SQLException  {
    boolean rc = false;
    if (warn != null) {
      CreaXML.taskOutput.append ("\n*** Attenzione! ***\n");
      rc = true;
      while (warn != null) {
	CreaXML.taskOutput.append ("Stato    : " +warn.getSQLState ());
	CreaXML.taskOutput.append ("\nMessaggio: " +warn.getMessage ());
	CreaXML.taskOutput.append ("\nCodice   : " +warn.getErrorCode ()+"\n");
	warn = warn.getNextWarning ();
      }
    }
    return rc;
  }
}
